Structure zaehler
  sp1.l
  sp2.l
EndStructure
Structure pos
  x.l
  y.l
  spieler.b
EndStructure
Structure replay
  zugnummer.l
  spieler.b
EndStructure
Structure rueckgang
  felder.b[8 * 8]
EndStructure



#spieler1 = '1'
#spieler2 = '2'
#leer = '-'

Global NewList zuege.pos()

Global Dim brett.b(7,7)
Global Dim bewertung(7,7)
Global Dim maske(7,7)

Global Dim replay.replay(7,7)
Global Dim replay2.replay(7,7)
Global replay_zaehler.l
Global play_zaehler.l

Global NewList rueckgang.rueckgang()



Restore maske
For z2=0 To 7
  For z1=0 To 7
    Read maske(z1,z2)
  Next
Next






Procedure init()
  Protected z1.l, z2.l
  Shared ende
  
  ClearList(zuege())
  
  For z1 = 0 To 7
    For z2 = 0 To 7
      brett(z1,z2) = #leer
    Next
  Next
  
  brett(3,3) = #spieler1
  brett(4,4) = #spieler1
  
  brett(3,4) = #spieler2
  brett(4,3) = #spieler2
  
  AddElement(rueckgang())
  CopyMemory(@brett(),@rueckgang(),8 * 8)
  
  ende = 0
EndProcedure

Procedure.b check_horizontal_links(x.l,y.l,spieler.b)
  Protected z1.l
  
  z1 = x - 1
  While z1 >= 0 And brett(z1,y) <> spieler And brett(z1,y) <> #leer
    z1 - 1
  Wend
  
  If z1 >= 0 And brett(z1,y) = spieler And x - z1 > 1
    ProcedureReturn #True
  EndIf
  
  ProcedureReturn #False
EndProcedure

Procedure.b check_horizontal_rechts(x.l,y.l,spieler.b)
  Protected z1.l
  
  z1=x+1
  While z1<8 And brett(z1,y)<>spieler And brett(z1,y)<>#leer
    z1+1
  Wend
  
  If z1<8 And brett(z1,y)=spieler And z1-x>1
    ProcedureReturn #True
  EndIf
  
  ProcedureReturn #False
EndProcedure

Procedure.b check_vertikal_oben(x.l,y.l,spieler.b)
  Protected z2.l
  
  z2=y-1
  While z2>=0 And brett(x,z2)<>spieler And brett(x,z2)<>#leer
    z2-1
  Wend
  
  If z2>=0 And brett(x,z2)=spieler And y-z2>1
    ProcedureReturn #True
  EndIf
  
  ProcedureReturn #False
EndProcedure

Procedure.b check_vertikal_unten(x.l,y.l,spieler.b)
  Protected z2.l
  
  z2=y+1
  While z2<8 And brett(x,z2)<>spieler And brett(x,z2)<>#leer
    z2+1
  Wend
  
  If z2<8 And brett(x,z2)=spieler And z2-y>1
    ProcedureReturn #True
  EndIf
  
  ProcedureReturn #False
EndProcedure

Procedure.b check_diagonal1_rechts(x.l,y.l,spieler.b)
  Protected z1.l, z2.l
  
  z1=x+1
  z2=y-1
  While z1<8 And z2>=0 And brett(z1,z2)<>spieler And brett(z1,z2)<>#leer
    z1+1
    z2-1
  Wend
  
  If z1<8 And z2>=0 And brett(z1,z2)=spieler And z1-x>1
    ProcedureReturn #True
  EndIf
  
  ProcedureReturn #False
EndProcedure

Procedure.b check_diagonal1_links(x.l,y.l,spieler.b)
  Protected z1.l, z2.l
  
  z1 = x - 1
  z2 = y + 1
  While z1 >= 0 And z2 < 8 And brett(z1,z2) <> spieler And brett(z1,z2) <> #leer
    z1 - 1
    z2 + 1
  Wend
  
  If z1>=0 And z2<8 And brett(z1,z2)=spieler And x-z1>1
    ProcedureReturn #True
  EndIf
  
  ProcedureReturn #False
EndProcedure

Procedure.b check_diagonal2_rechts(x.l,y.l,spieler.b)
  Protected z1.l, z2.l
  
	z1 = x + 1
	z2 = y + 1
	While z1 < 8 And z2 < 8 And brett(z1,z2) <> spieler And brett(z1,z2) <> #leer 
		z1 + 1
		z2 + 1
  Wend
    
  If z1 < 8 And z2 < 8 And brett(z1,z2) = spieler And z1 - x > 1
    ProcedureReturn #True
  EndIf  
  
  ProcedureReturn #False
EndProcedure

Procedure.b check_diagonal2_links(x.l,y.l,spieler.b)
  Protected z1.l, z2.l
  
	z1 = x - 1
	z2 = y - 1
	While z1 >= 0 And z2 >= 0 And brett(z1,z2) <> spieler And brett(z1,z2) <> #leer 
		z1 - 1
		z2 - 1
  Wend
  
  If z1 >= 0 And z2 >= 0 And brett(z1,z2) = spieler And x - z1 > 1
    ProcedureReturn #True
  EndIf  
  
  ProcedureReturn #False
EndProcedure

Procedure.b umkehren(x.l,y.l,spieler.b)
  Protected z1.l, z2.l, valid.b, rueckgang.b
  
  valid     = #False
  rueckgang = #False
  If check_horizontal_links(x,y,spieler)
    If rueckgang = #False And spieler = #spieler1
      AddElement(rueckgang())
      CopyMemory(@brett(),@rueckgang(),8 * 8)
    EndIf
    rueckgang.b = #True
    
    valid = #True
    z1 = x - 1
    While brett(z1,y) <> spieler 
			brett(z1,y) = spieler
      InsertElement(zuege())
      zuege()\x = z1
      zuege()\y = y
      zuege()\spieler = spieler
			z1					= z1 - 1
    Wend
  EndIf
  
  If check_horizontal_rechts(x,y,spieler)
    If rueckgang = #False And spieler = #spieler1
      AddElement(rueckgang())
      CopyMemory(@brett(),@rueckgang(),8 * 8)
    EndIf
    rueckgang.b = #True
    
    valid = #True
		z1		= x + 1
		While brett(z1,y) <> spieler 
			brett(z1,y)  = spieler
      InsertElement(zuege())
      zuege()\x = z1
      zuege()\y = y
      zuege()\spieler = spieler
			z1					 = z1 + 1
    Wend
  EndIf
  
  If check_vertikal_oben(x,y,spieler)
    If rueckgang = #False And spieler = #spieler1
      AddElement(rueckgang())
      CopyMemory(@brett(),@rueckgang(),8 * 8)
    EndIf
    rueckgang.b = #True
    
    valid = #True
		z2		= y - 1
		While brett(x,z2) <> spieler
			brett(x,z2)  = spieler
      InsertElement(zuege())
      zuege()\x = x
      zuege()\y = z2
      zuege()\spieler = spieler
			z2					 = z2 - 1
    Wend
  EndIf
  
  If check_vertikal_unten(x,y,spieler)
    If rueckgang = #False And spieler = #spieler1
      AddElement(rueckgang())
      CopyMemory(@brett(),@rueckgang(),8 * 8)
    EndIf
    rueckgang.b = #True
    
    valid = #True
		z2		= y + 1
		While brett(x,z2) <> spieler 
			brett(x,z2)  = spieler
      InsertElement(zuege())
      zuege()\x = x
      zuege()\y = z2
      zuege()\spieler = spieler
			z2					 = z2 + 1
    Wend
  EndIf
  
  If check_diagonal1_rechts(x,y,spieler)
    If rueckgang = #False And spieler = #spieler1
      AddElement(rueckgang())
      CopyMemory(@brett(),@rueckgang(),8 * 8)
    EndIf
    rueckgang.b = #True
    
    valid = #True
		z1		= x + 1
		z2		= y - 1
		While brett(z1,z2) <> spieler 
			brett(z1,z2) = spieler
      InsertElement(zuege())
      zuege()\x = z1
      zuege()\y = z2
      zuege()\spieler = spieler
			z1					 = z1 + 1
			z2					 = z2 - 1
    Wend
  EndIf
  
  If check_diagonal1_links(x,y,spieler)
    If rueckgang = #False And spieler = #spieler1
      AddElement(rueckgang())
      CopyMemory(@brett(),@rueckgang(),8 * 8)
    EndIf
    rueckgang.b = #True
    
    valid = #True
		z1		= x - 1
		z2		= y + 1
		While brett(z1,z2) <> spieler
			brett(z1,z2) = spieler
      InsertElement(zuege())
      zuege()\x = z1
      zuege()\y = z2
      zuege()\spieler = spieler
			z1						= z1 - 1
			z2						= z2 + 1
    Wend
  EndIf
  
  If check_diagonal2_rechts(x,y,spieler)
    If rueckgang = #False And spieler = #spieler1
      AddElement(rueckgang())
      CopyMemory(@brett(),@rueckgang(),8 * 8)
    EndIf
    rueckgang.b = #True
    
    valid = #True
		z1		= x + 1
		z2		= y + 1
		While brett(z1,z2) <> spieler
			brett(z1,z2) = spieler
      InsertElement(zuege())
      zuege()\x = z1
      zuege()\y = z2
      zuege()\spieler = spieler
			z1						= z1 + 1
			z2						= z2 + 1
    Wend
  EndIf
  
  If check_diagonal2_links(x,y,spieler)
    If rueckgang = #False And spieler = #spieler1
      AddElement(rueckgang())
      CopyMemory(@brett(),@rueckgang(),8 * 8)
    EndIf
    rueckgang.b = #True
    
    valid = #True
		z1		= x - 1
		z2		= y - 1
		While brett(z1,z2) <> spieler
			brett(z1,z2) = spieler
      InsertElement(zuege())
      zuege()\x = z1
      zuege()\y = z2
      zuege()\spieler = spieler
			z1						= z1 - 1
			z2						= z2 - 1
    Wend
  EndIf
  
  ProcedureReturn valid
EndProcedure

Procedure.b setzen(x.l,y.l,spieler.b) 
  If brett(x,y) <> #leer
    ProcedureReturn #False
  EndIf
  
  If umkehren(x,y,spieler)
    brett(x,y) = spieler
    InsertElement(zuege())
    zuege()\x = x
    zuege()\y = y
    zuege()\spieler = spieler
    
    replay_zaehler + 1
    replay(x,y)\zugnummer = replay_zaehler
    replay(x,y)\spieler   = spieler
    
    ProcedureReturn #True
  EndIf
  
  ProcedureReturn #False
EndProcedure

Procedure bewerten(x.l,y.l,spieler.b)
  Protected z1.l, z2.l
  
	If check_horizontal_links(x, y, spieler) 
		z1 = x - 1
		While brett(z1,y) <> spieler
			bewertung(x,y) + 1
			z1 - 1
    Wend
  EndIf
  
  If check_horizontal_rechts(x, y, spieler)
		z1 = x + 1
		While brett(z1,y) <> spieler
			bewertung(x,y) + 1
			z1 + 1
    Wend
  EndIf
  
  If check_vertikal_oben(x, y, spieler)
		z2 = y - 1
		While brett(x,z2) <> spieler
			bewertung(x,y) + 1
			z2 - 1
    Wend
  EndIf
  
  If check_vertikal_unten(x, y, spieler)
		z2 = y + 1
		While brett(x,z2) <> spieler
			bewertung(x,y) + 1
			z2 + 1
    Wend
  EndIf
  
  If check_diagonal1_rechts(x, y, spieler)
		z1 = x + 1
		z2 = y - 1
		While brett(z1,z2) <> spieler
			bewertung(x,y) + 1
			z1 + 1
			z2 - 1
    Wend
  EndIf
  
  If check_diagonal1_links(x, y, spieler)  
		z1 = x - 1
		z2 = y + 1
		While brett(z1,z2) <> spieler
			bewertung(x,y) + 1
			z1 - 1
			z2 + 1
    Wend
  EndIf
  
  If check_diagonal2_rechts(x, y, spieler)
		z1 = x + 1
		z2 = y + 1
		While brett(z1,z2) <> spieler
			bewertung(x,y) + 1
			z1 + 1
			z2 + 1
    Wend
  EndIf
  
  If check_diagonal2_links(x, y, spieler) 
		z1 = x - 1
		z2 = y - 1
		While brett(z1,z2) <> spieler
			bewertung(x,y) + 1
			z1 - 1
			z2 - 1
    Wend
  EndIf
  
EndProcedure

Procedure.l computerzug(spieler.b) ;1 = gelegt, 2 = nicht gelegt
  Protected z1.l, z2.l
  Protected bestwert.l, bestx.l,besty.l
  
  For z1 = 0 To 7
		For z2 = 0 To 7 
			bewertung(z1,z2) = 0
			If brett(z1,z2) = #leer 
				bewerten(z1, z2, spieler)
				If bewertung(z1,z2) <> 0
					bewertung(z1,z2) + maske(z1,z2)
        EndIf
      EndIf
    Next
  Next
  
  bestwert = 0
	For z1 = 0 To 7
		For z2 = 0 To 7
			If bestwert < bewertung(z1,z2)
				bestwert = bewertung(z1,z2)
				bestx		 = z1
        besty    = z2
      EndIf
    Next
  Next
  
  If bestwert <> 0
		;printn(str(bestx + 1) + " " + str(besty + 1))
		setzen(bestx, besty, spieler)
		ProcedureReturn 1
  EndIf
  
  ProcedureReturn 2
EndProcedure

Procedure.l check_finish(spieler.b) ;0 = ende; 1 = spieler kann; 2 = spieler berspringen; 3 = einfarbig
  Protected z1.l, z2.l, voll.b, einfarbig.b, farbe.b
  
  einfarbig = #True
  farbe = 3
  voll = #True
  For z1 = 0 To 7
		For z2 = 0 To 7
			If brett(z1,z2) = #leer
				voll = #False
				If check_horizontal_rechts(z1, z2, spieler) Or check_horizontal_links(z1, z2, spieler) Or check_vertikal_oben(z1, z2, spieler) Or check_vertikal_unten(z1, z2, spieler) Or check_diagonal1_links(z1, z2, spieler) Or check_diagonal1_rechts(z1, z2, spieler) Or check_diagonal2_links(z1, z2, spieler) Or check_diagonal2_rechts(z1, z2, spieler)
					ProcedureReturn 1
        EndIf
      EndIf
      If einfarbig = #True
        If brett(z1,z2) <> #leer
          If farbe = 3
            farbe = brett(z1,z2)
          ElseIf farbe <> brett(z1,z2)
            einfarbig = #False
          EndIf
        EndIf
      EndIf
    Next
  Next
  
  If voll
    ProcedureReturn 0
  ElseIf einfarbig
    ProcedureReturn 3
  EndIf
  
  ProcedureReturn 2
EndProcedure

Procedure zaehler(*zaehler.zaehler)
  Protected z1.l, z2.l, anz_spieler1.l, anz_spieler2.l
  anz_spieler1 = 0
	anz_spieler2 = 0
  
  For z1 = 0 To 7
		For z2 = 0 To 7
			Select brett(z1,z2) 
        Case #spieler1
          anz_spieler1 + 1
        Case #spieler2
          anz_spieler2 + 1
      EndSelect
    Next
  Next
  
  *zaehler\sp1 = anz_spieler1
  *zaehler\sp2 = anz_spieler2
  
EndProcedure













DataSection
maske:
Data.l 9, 0, 6, 4, 4, 6, 0, 9
Data.l 0, 0, 6, 3, 3, 6, 0, 0
Data.l 6, 6, 6, 3, 3, 6, 6, 6
Data.l 4, 3, 3, 4, 4, 3, 3, 4
Data.l 4, 3, 3, 4, 4, 3, 3, 4
Data.l 6, 6, 6, 3, 3, 6, 6, 6
Data.l 0, 0, 6, 3, 3, 6, 0, 0
Data.l 9, 0, 6, 4, 4, 6, 0, 9
EndDataSection

; IDE Options = PureBasic 4.00 - Beta 1 (Linux - x86) - (c) 2006 Fantaisie Software
; CursorPosition = 17
; FirstLine = 10
; Folding = ----
; SubSystem = gtk2